angular.module('PasswordMonitor').controller('DataUploadModalCtrl', function ($scope) {

    $scope.stage = 0;

    $scope.startUpload = function () {
        $scope.inProgress = true;
        var port = chrome.runtime.connect({name: 'uploadData'});
        port.onMessage.addListener(function (message) {
            if (message) {
                if (message.inProgress) {
                    $scope.$apply(function () {
                        if (message.stage) {
                            $scope.stage = message.stage;
                        }
                        if (message.text) {
                            $scope.statusText = message.text;
                        }
                        if (message.percentage) {
                            $scope.percentage = message.percentage;
                        }
                    });
                }
                else if (message.success) {
                    $scope.$apply(function () {
                        $scope.inProgress = false;
                        $scope.success = true;
                    });
                }
                else if (message.error) {
                    $scope.$apply(function () {
                        $scope.inProgress = false;
                        $scope.error = true;
                        $scope.errorCode = message.errorCode;
                        $scope.errorText = message.error;
                    });
                }
            }
        });
    }
});