/**
 * Created by Nikolai on 04/04/15.
 */
describe('HashingService', function () {

    var service, q, rootScope;
    beforeEach(function () {
        module('PasswordMonitor', function ($provide) {
            $provide.decorator('$window', function ($delegate) {
                $delegate.chrome = {
                    storage: {
                        local: {
                            get: function (salt, callback) {
                                if (salt === 'salt') {
                                    callback({salt: 'SOME_SALT'});
                                }
                            }
                        }
                    }
                };
                return $delegate;
            })
        });
        inject(function (HashingService, $q, $rootScope) {
            service = HashingService;
            q = $q;
            rootScope = $rootScope;
        })
    });

    it('should be defined', function () {
        expect(service).toBeDefined();
    });

    it('should have functions exposed', function () {
        expect(service.hashThis).toBeDefined();
        expect(service.hashThis).toEqual(jasmine.any(Function));
        expect(service.getSalt).toBeDefined();
        expect(service.getSalt).toEqual(jasmine.any(Function));
    });

    describe('hashThis', function () {
        it('should hash correctly', function () {
            spyOn(service, 'hashThis').and.callFake(function (cleartext) {
                var deferred = q.defer();
                if (cleartext === 'first') {
                    deferred.resolve('firstHashed');
                }
                else if (cleartext === 'second') {
                    deferred.resolve('secondHashed');
                }
                return deferred.promise;
            });
            var hashResult;
            q.all({
                first: service.hashThis('first'),
                second: service.hashThis('second')
            }).then(function (result) {
                hashResult = result;
            });
            rootScope.$digest();
            expect(hashResult).toBeDefined();
            expect(hashResult.first).toBeDefined();
            expect(hashResult.second).toBeDefined();
            expect(hashResult.first.length).toEqual(11);
            expect(hashResult.second.length).toEqual(12);
            expect(hashResult.first).not.toEqual(hashResult.second);
        });
    })
});
