describe('EmailModalCtrl', function () {

    var ctrl, scope;
    var modalInstance = {
        close: function () {
        }
    };
    beforeEach(function () {
        module('PasswordMonitor');
        inject(function ($controller, $rootScope) {
            scope = $rootScope.$new();
            ctrl = $controller('EmailModalCtrl', {
                $scope: scope,
                $modalInstance: modalInstance
            });
        });
    });

    it('should have scope objects instantiated', function () {
        expect(scope.email).toBe("");
        expect(scope.accept).toBeDefined();
        expect(scope.accept).toEqual(jasmine.any(Function));
    });

    describe('accept function', function () {
        it('should set alert to true when email is empty', function () {
            scope.accept();
            expect(scope.alert).toBeTruthy();
        });

        it('should send message and close modal when email is not empty', function () {
            spyOn(window.chrome.runtime, 'sendMessage');
            spyOn(modalInstance, 'close');
            scope.email = "something";
            scope.accept();
            expect(window.chrome.runtime.sendMessage).toHaveBeenCalledWith({'type': 'setEmail', 'email': 'something'});
            expect(modalInstance.close).toHaveBeenCalled();
        });
    })
});